package com.uas.cloud.mall.shop.news.data;

import com.uas.cloud.mall.shop.news.model.News;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import javax.persistence.QueryHint;
import java.util.List;

/**
 * Created by dongbw on 2017年2月25日 17:56:50.
 */
@Repository
public interface NewsRepository extends JpaSpecificationExecutor<News>, JpaRepository<News, Long> {

    /**
     * 根据新闻类型筛选新闻id
     * @param taskName
     * @return
     */
    @Query(value = " select c.id from\n" +
            " jpress_content c \n" +
            " join jpress_mapping m on c.id = m.content_id \n" +
            " join jpress_taxonomy t on m.taxonomy_id = t.id \n" +
            " where 1=1 and t.slug = :name and c.status = 'normal'",nativeQuery = true)
    @QueryHints({@QueryHint(name = "org.hibernate.cacheable", value ="true")})
    List<Long> findNewsIdByTaxonomySlug (@Param("name")String taskName);

    @Modifying
    @Query("update News set viewCount = viewCount + 1 where id = :id")
    void addCount(@Param("id")Long Id);
}
