package com.uas.cloud.mall.shop.news.utils;

import com.uas.cloud.mall.shop.news.model.News;
import org.apache.commons.collections.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by wangdy on 2017/5/27.
 */
public class NewsCloumnCutUtil {

    public static List<News> cutText(List<News> oldnewsList) {
        List<News> newsList = new ArrayList<>();
        if (CollectionUtils.isEmpty(oldnewsList)) {
            return newsList;
        }
        for (News news : oldnewsList) {
            if ("".equals(news.getSummary()) || news.getSummary() == null) {
                news.setSummary(getHtmlText(100, news.getContent()));
            }
            news.setContent("");
            newsList.add(news);
        }
        return newsList;
    }

    //从html中提取纯文本
    public static String getHtmlText(int len , String inputString) {
        String htmlStr = inputString; // 含html标签的字符串
        String textStr = "";
        if (htmlStr == null ){
            return htmlStr;
        }
        textStr = htmlStr.replaceAll("\n", ""); //剔出回车
        textStr = textStr.replaceAll("&nbsp", ""); //剔出空格
        textStr = textStr.replaceAll("</?[^>]+>", ""); //剔出<html>的标签
        textStr = textStr.replaceAll("<a>\\s*|\t|\r|\n</a>", "");//去除字符串中的空格,回车,换行符,制表符

        if (len > textStr.length()){
            return textStr;
        } else {
            return textStr.substring(0,len);
        }
    }


}
